//
//  ColorExtensionGenerator.swift
//  
//
//  Created by Thibaut Schmitt on 20/12/2021.
//

import Foundation

struct ColorExtensionGenerator {
    
    let colors: [GenColor]
    let extensionClassname: String
    let isUIColorExtension: Bool
    
    func getHeader() -> String {
        """
        // Generated from ColorToolCore at \(Date())

        import UIKit

        extension \(extensionClassname) {\n
        """
    }
    
    func getFooter() -> String {
        """
        }
        """
    }
    
    func getProperties() -> String {
        colors.map {
            if extensionClassname == ColorTool.defaultExtensionName {
                return $0.getColorStaticProperty()
            }
            return $0.getColorProperty()
        }
        .joined(separator: "\n\n")
    }
}
